<template>
	<mobile-frame>
		<view class="main">
			<view class="one">
				<view class="one_1">
					<text>{{integral||0}}</text><text>分</text>
				</view>
				<view class="one_2" @click="toRecord">
					<button type="default" size="mini">礼品兑换记录</button>
				</view>
			</view>
			<view class="two">
				<scroll-view scroll-y="true" class="scroll-view" @scrolltolower="toPage" @scroll="toScroll">
					<view class="list-scroll-view">
						<view class="list" v-for="(item, index) in list" :key="index">
							<view class="other">
								<view class="other_1">积分: <text class="integral">{{item.point}}</text></view>
								<view class="other_1">状态: <text>{{item.zhStatus}}</text></view>
								<view class="other_1">来源: <text>{{item.zhSource}}</text></view>
								<view class="other_1">时间: <text>{{item.time}}</text></view>
							</view>
						</view>
						<view class="is_bottom" v-if="is_bottom">
							<text>{{config.bottom_title}}</text>
						</view>
					</view>
				</scroll-view>
			</view>
		</view>
	</mobile-frame>
</template>

<script>
	export default {
		data() {
			return {
				// 系统设置
				config: {},
				user: {},
				integral: '',
				list: [],
				total: 0,
				skip: 0,
				limit: 10,
				page: 0,
				// 状态
				statusList: [],
				// 来源
				sourceList: [],
				// 数据是否触底
				is_bottom: false,
				scrollTop: 0,
			};
		},
		onShow: async function() {
			const that = this;
			that.searchConfig();
			await that.searchOther();
			await that.watchLogin();

		},
		onHide: function() {
			const that = this;
			that.clearPage();
		},
		onPullDownRefresh: async function() {
			const that = this;
			that.clearPage();
			await that.search();
			uni.stopPullDownRefresh();
		},
		methods: {

			// 查询基本设置
			searchConfig() {
				const that = this;
				uni.getStorage({
					key: 'config',
					success: function(res) {
						if (res.data) that.$set(that, `config`, res.data)
					},
					fail: function(err) {
						console.log(err);
					}
				})
			},
			watchLogin() {
				const that = this;
				uni.getStorage({
					key: 'token',
					success: function(res) {
						let user = that.$jwt(res.data);
						that.$set(that, `user`, user)
						that.search()
					}
				})
			},
			// 查询列表
			async search() {
				const that = this;
				let user = that.user;
				if (user._id) {
					let info = {
						skip: that.skip,
						limit: that.limit,
						customer: user._id,
					}
					let res = await that.$api(`/point`, 'GET', {
						...info,
					})
					if (res.errcode == '0') {
						let list = [...that.list, ...res.data];
						for (let val of list) {
							let status = that.statusList.find(i => i.value == val.status)
							if (status) val.zhStatus = status.label;
							let source = that.sourceList.find(i => i.value == val.source)
							if (source) val.zhSource = source.label;
						}
						that.$set(that, `list`, list);
						that.$set(that, `total`, res.total)
					}
					let arr = await that.$api(`/point/computedTotal`, 'GET', {
						customer: user._id
					})
					if (arr.errcode == '0') that.$set(that, `integral`, arr.data);
				}
			},
			// 分页
			toPage(e) {
				const that = this;
				let list = that.list;
				let limit = that.limit;
				if (that.total > list.length) {
					uni.showLoading({
						title: '加载中',
						mask: true
					})
					let page = that.page + 1;
					that.$set(that, `page`, page)
					let skip = page * limit;
					that.$set(that, `skip`, skip)
					that.search();
					uni.hideLoading();
				} else that.$set(that, `is_bottom`, true)
			},
			toScroll(e) {
				const that = this;
				let up = that.scrollTop;
				that.$set(that, `scrollTop`, e.detail.scrollTop);
				let num = Math.sign(up - e.detail.scrollTop);
				if (num == 1) that.$set(that, `is_bottom`, false);
			},
			// 查询其他信息
			async searchOther() {
				const that = this;
				let res;
				res = await that.$api(`/dictData`, 'GET', {
					code: "point_status"
				});
				if (res.errcode == '0') {
					that.$set(that, `statusList`, res.data)
				}
				res = await that.$api(`/dictData`, 'GET', {
					code: "point_source"
				});
				if (res.errcode == '0') {
					that.$set(that, `sourceList`, res.data)
				}
			},
			// 兑换记录
			toRecord() {
				uni.navigateTo({
					url: `/pagesIntegral/record/index`
				})
			},
			// 清空列表
			clearPage() {
				const that = this;
				that.$set(that, `list`, [])
				that.$set(that, `skip`, 0)
				that.$set(that, `limit`, 6)
				that.$set(that, `page`, 0)
			}
		}
	}
</script>

<style lang="scss">
	.main {
		display: flex;
		flex-direction: column;
		width: 100vw;
		height: 100vh;

		.one {
			background-color: var(--fFB1Color);
			padding: 5vw 2vw;
			display: flex;
			justify-content: space-between;

			.one_1 {
				color: #fff;
				font-size: 25px;
				font-weight: bold;

				text:last-child {
					padding: 0 0 0 2vw;
					font-size: 15px;
				}
			}

			.one_2 {
				button {
					background: #fff;
					color: #ff0000;
					border-radius: 25px;
					font-size: 14px;
				}
			}

		}

		.two {
			position: relative;
			flex-grow: 1;
			padding: 2vw 0 0 0;

			.list {
				width: 92vw;
				border: 0.5vw solid var(--f1Color);
				margin: 2vw 2vw 0 1.5vw;
				padding: 2vw;
				border-radius: 5px;

				.other {
					.other_1 {
						font-size: var(--font16Size);
						margin: 0 0 1vw 0;

						.integral {
							color: #ff0000;
						}

						text {
							margin: 0 0 0 2vw;
							color: var(--f85Color);
							font-size: var(--font14Size);
						}
					}
				}
			}
		}
	}

	.scroll-view {
		position: absolute;
		top: 0;
		left: 0;
		right: 0;
		bottom: 0;

		.list-scroll-view {
			display: flex;
			flex-direction: column;
		}
	}

	.is_bottom {
		text-align: center;

		text {
			padding: 2vw 0;
			display: inline-block;
			color: #858585;
			font-size: 14px;
		}
	}
</style>
